

                    {UNIT...UNIT...UNIT...UNIT...UNIT}

   UNIT TERRE;

   {Cette procedure donne les ephemerides de la TERRE moyennant les
   precautions suivantes:

        Donner la variable datir sous forme de chaine,par exemple
        le 3 mai 1986 sera note datir='03051986'.

        Donner l'heure sous forme de chaine,par exemple 8h5mn7s
        fournira la variable heure='080507' .

    En sortie le programme fournit les resultats suivants:


          NB:Tous les calculs sur les angles sont operes en radians
             Par contre si vous demandez les resultats imprimes vous
             les aurez en degres(pour cela la variable IMPRIM=1 sinon
             IMPRIM=0).

        Le rayon vecteur de la TERRE dans le repere j 2000 avec comme
        unite le km.
        La vitesse de la TERRE dans j2000,les composantes sont donnees
        en km/s.
        La longitude heliocentrique ecliptique en degres decimaux.
        Le jour julien correspondant a la date

        Les parametres orbitaux de la planete:
          param[1]:demi grand axe en km.
          param[2]:excentricite.
          param[3]:inclinaison en degres.
          param[4]:argument nodal du perihelie.
          param[5]:longitude vernale de la ligne des noeuds en degres.
          param[6]:anomalie excentrique de la position en degres.
          param[7]:date julienne de passage prochain  au perihelie

        NB:Les calculs internes au programme sont effectues en radian
           et dans le cas d un passage de parametres ceux-ci seront
           transmis en radian,les autres en km ou km/ s.}

    INTERFACE

    uses constype,jourjuli,paramrv,fonscal;


      procedure ephemterre(datir,heure:string;mus:real;imprim:integer;
      var param:tabparam;var r,v:vecteur);


    IMPLEMENTATION

        const v1:array[1..5] of real=(1.753470314,-0.003740816,0.016284477,
                                      0,0);
              v2:array[1..5] of real=(6283.319663,-0.004793106,-0.001532379,
                                      0,0);
              v3:array[1..5] of real=(5.3001819e-4,2.81128e-4,7.20171e-4,
                                      0,0);
              v4:array[1..5] of real=(3.69e-7,7.3831e-5,3.2299e-5,0,0);
              a:real=1.00000101778;
              mm:real=0.985609113;
              au:real=1.49597893e8;
        procedure ephemterre;

         var i:integer;
             par:array[1..5] of real;
             sn2,x,mj,sj,jj2000,jjancien,l:real;
             p,q,w:vecteur;

         BEGIN

           datejuli(datir,heure,mj,sj,jj2000,jjancien);

           for i:=1 to 5 do
              begin
               par[i]:=v1[i]+mj*(v2[i]+mj*(v3[i]+mj*v4[i]));
              end;
          {Calcul de a et e}

           param[1]:=a*au;
           param[2]:=sqrt(par[2]*par[2]+par[3]*par[3]);

          {Calcul de l'inclinaison i}

           sn2:=par[4]*par[4]+par[5]*par[5];
           param[3]:=2*arctan(sqrt(sn2/(1-sn2)));

          {Calcul de l'argument nodal du perihelie}

           param[4]:=arctan(par[3]/par[2]);
           if (par[2]<0) then param[4]:=param[4]+pi;

           {Calcul de l anomalie excentrique fi valeur entre 0 et pi}

           x:=(par[1]-param[4])-int((par[1]-param[4])/2/pi)*2*pi;
           if (x<0) then x:=x+2*pi;

          {Resolution de l equation transcendante donnant fi}

           for i:=1 to 10 do
             begin
               param[6]:=x+param[2]*sin(param[6]);
             end;

         {Calcul du temps tp de passage suivant au perihelie}

            param[7]:=jj2000+param[1]*sqrt(param[1]/mus)*(2*pi-param[6]
                        +param[2]*sin(param[6]))/86400;

         {Longitude vernale du noeud ascendant nulle pour la terre}

            param[5]:=0;

         {Calcul grace a la procedure posvitperifocal de la position r,
         de la vitesse v, et des vecteurs p,q,r du repere perifocal.}

           posvitperifocal(mus,param,p,q,w,r,v);

          {Calcul de la longitude heliocentrique de la terre}

          l:=arctan(r[2]/r[1]);
          if (((r[1]<0) and (r[2]>0)) or ((r[1]<0) and (r[2]<0)))
                    then l:=l+pi
                    else
                         if ((r[2]<0) and (r[1]>0))
                            then l:=2*pi+l;
           

         {Impression des resultats sur demande}

           if (imprim=1) then

             begin
              writeln('*******Caracteristiques de la terre********');
              writeln('      Demi grand axe a=',param[1]/1e6:8:3,' e6 km');writeln;
              writeln('      Excentricite:',param[2]:7:5);writeln;
              writeln('      Inclinaison:',param[3]*180/pi:6:2,' degres');writeln;
              writeln('      Argument nodal du perihelie:',param[4]*180/pi:6:2,
                      ' degres');writeln;
              writeln('      Longitude vernale de la ligne des noeuds',
                      param[5]*180/pi:6:2,' degres');writeln;
              writeln('      Anomalie excentrique:',param[6]*180/pi:6:2,' degres');
                      writeln;
              writeln('      La date du ',datir,' est le jour julien:  ',jj2000:11:5);
              writeln('      Le premier passage au perihelie aura lieu le ',param[7]:11:5,
                       ' jour julien');writeln;
              writeln('      Voici dans le repere j2000 les composantes de:');
              writeln('      Rayon en km: r1=',r[1]/1e6:8:3,' e6 ','r2=',r[2]/1e6:8:3,' e6 ','r3= ',r[3]/1e6:8:3,' e6');
              writeln('      Vitesse en km/s :V1= ',v[1]:7:3,'  V2= ',v[2]:7:3,'  V3= ',v[3]:7:3); writeln;
              writeln('**********************************************');
              writeln('      longitude heliocentrique: ',l*180/pi:6:2,'  degres');
              {writeln('      Latitude heliocentrique: ',lambda*180/pi:6:2,'  degres');}

              end;
         end;

        end.







