UNIT DATECAL;

{*****************************************COMMENTAIRES*****************************************
Cette unit convertit une date julienne nouvelle compte  partir du 01/01/2000  12 h 00 mn 00 s en
date du calendrier normal

 ATTENTION la date doit tre comprise entre 01/01/1980 et 31/12/2019

 Donc la date julienne entre -7305 ET +7304

 VARIABLE D'ENTREE : DateJuli : un rel, date julienne nouvelle, compte depuis le 1/1/2000  12 h 00 mn 00 s

 VARIABLES DE SORTIE :
   annee:integer, obligatoirement entre 1980 et 2019
   Mois; integer, le numro du mois;
   JourMois:integer, numro du jour dans le mois
   Heure,minute,seconde :integer, heures,minutes et secondes , videntes

   Sign: GUIZIOU Robert, dcembbre 2000

***********************************************************************************************}


INTERFACE

uses Wincrt;

PROCEDURE DATE_CAL(datejuli:real;var annee,mois,jourmois,heure,minute,seconde:integer);

IMPLEMENTATION

PROCEDURE DATE_CAL(datejuli:real;var annee,mois,jourmois,heure,minute,seconde:integer);

  type tableau12=array[0..11] of integer;

  const nonbis:tableau12 =(31,59,90,120,151,181,212,243,273,304,334,365);
			bis:tableau12=(31,60,91,121,152,182,213,244,274,305,335,366);
			numeroJourNonbis:tableau12=(31,28,31,30,31,30,31,31,30,31,30,31);

			numeroJourbis:tableau12=(31,29,31,30,31,30,31,31,30,31,30,31);

 VAR   joursrestants,temps:real;
       TotalJourMois,numero:tableau12;
       ch,reponse:char;
       bissex,i,k,reste:integer;
       AnneeJulienne:Array[1980..2020] of real;
       CAS:integer;

 LABEL FIN;

 BEGIN

 if ((datejuli>7304) or (datejuli<-7305)) then
  Begin
    WriteLn;
    writeLn('     DATE HORS LIMITES ??????');
    WriteLn;
    GOTO FIN;
 end;

{Calcul de la date julienne des annees 1980  2020 , on rappelle
que le 01/01/2000 a 12 h est le jour julien 0, et que le 01/01/1980 12 h est JJ=-7305.5}

AnneeJulienne[1980]:= -7305.5;

For i:=1 to 40 do

	Begin

	{Test de l annee bissextile}

	 If ((1980+i-1) MOD(4))=0 then bissex:=1 else bissex:=0;

	 AnneeJulienne[1980+i]:=AnneeJulienne[1980+i-1]+365+BISSEX;

	End;

{Calcul preliminaire de la date julienne a zero heure}


{Calcul de l annee}

For i:=0 to 39 do

	Begin
                If abs(datejuli+7305.5)<0.5 then annee:=1980;

		if datejuli=AnneeJulienne[1980+i]+0.5 then
		 begin
			annee:=1980+i;
			k:=i;
		 end;

		If (datejuli<(AnneeJulienne[1980+i+1]+0.5)) and (datejuli>(AnneeJulienne[1980+i]+0.5))
		then
			 begin
			 annee:=1980+i;
			 k:=i;
		end;

		If datejuli=AnneeJulienne[2020]+0.5 then
			begin
				annee:=2020;
				k:=40;
			end;

	End;

{Calcul du mois de l annee}

JoursRestants:=Round(Int(datejuli-AnneeJulienne[1980+k]));


If (annee MOD(4)=0) then
	begin
		TotalJourMois:=bis;
		numero:=numeroJourbis;
	end

else
	begin
		TotalJourMois:=nonbis;
		numero:=numeroJournonbis;
	end;

mois:=1;

	for i:=0 to 10 do

	begin

		if (JoursRestants<TotalJourMois[0])  then

			begin
				mois:=1;
				reste:=round(JoursRestants)+1;

			end;

		if JoursRestants=TotalJourMois[i] then
	           begin
			 mois:=i+2;
			 reste:=1;
		    end;

		if (JoursRestants>TotalJourMois[i]) and (JoursRestants<TotalJourMois[i+1])
		then
                   begin
			 mois:=i+2;
			 reste:=round(JoursRestants-TotalJourMois[i])+1;
                   end;

		if (JoursRestants=TotalJourMois[i+1]) then
                  begin
			mois:=i+2;
			reste:=numero[i];
		 end;

	end;

 {Calcul de l heure }

 temps:=frac(datejuli-0.5);

 if temps<0 then temps:=temps+1;

 heure:=round(Int(temps*24));
 temps:=(temps*24-heure)*60;
 minute:=round(Int(temps));
 temps:=(temps-minute)*60;
 seconde:=round(temps);

 if (datejuli+0.5)*datejuli<0   then
 begin
  JourMois:=31;
  Mois:=12;
  annee:=1999;
 end;

 if (datejuli+0.5)*datejuli>=0 then
 begin
   JourMois:=reste;
 end;

FIN:

END;


END.