

                    {UNIT...UNIT...UNIT...UNIT...UNIT}

   UNIT PARAMRVH;

   {Cette procedure calcule connaissant les parametres orbitaux et
   la constante mu de gravitation de l'astre :
          le rayon vecteur r dans les axes absolus en km.
          la vitesse v dans les axes absolus en km/s.
          les vecteurs p,q w du repere perifocal par leurs composantes
          dans le repere absolu

   On rappelle que param doit etre un tableau a 7 elements:

          param(1):demi grand axe en km
          param(2):excentricite
          param(3):inclinaison en radian
          param(4):petit omega:argument nodal du perigee en radian
	  param(5):grand omega:longitude du noeud en radian
          param(6):fi anomalie excentrique en radian pour une ellipse et sans dimension
                   pour une hyperbole
          param(7):tp temps de premier passage au perigee en jours juliens, inutile ici

   Les angles doivent etre donnes en radian}

    INTERFACE

     uses fonvect,constype,fonscal;

     procedure posvitperifocalh(mu:real;param:tabparam;var p,q,w,r,v:vecteur);

    IMPLEMENTATION

     procedure posvitperifocalh(mu:real;param:tabparam;var p,q,w,r,v:vecteur);
      var rayon:real;
          vect1,vect2,result:vecteur;

     {Calcul du repere perifocal p,q,w}

     BEGIN

       p[1]:=cos(param[4])*cos(param[5])-sin(param[4])*cos(param[3])*
             sin(param[5]);
       p[2]:=cos(param[4])*sin(param[5])+sin(param[4])*cos(param[3])*
             cos(param[5]);
       p[3]:=sin(param[4])*sin(param[3]);


       q[1]:=-sin(param[4])*cos(param[5])-cos(param[4])*cos(param[3])*
             sin(param[5]);
       q[2]:=-sin(param[4])*sin(param[5])+cos(param[4])*cos(param[3])*
             cos(param[5]);
       q[3]:=cos(param[4])*sin(param[3]);

       prodvect(p,q,w);


     {********************** CAS ELLIPTIQUE ********************}
     If param[2]<1 then
      BEGIN
      {Calcul de la vitesse absolue v }

       scalvect(-sin(param[6]),p,vect1);
       scalvect(sqrt(1-param[2]*param[2])*cos(param[6]),q,vect2);
       somme(vect1,vect2,result);
       rayon:=param[1]*(1-param[2]*cos(param[6]));
       scalvect(sqrt(mu*param[1])/rayon,result,v);

     {Calcul du rayon vecteur r }

       scalvect((cos(param[6])-param[2]),p,vect1);
       scalvect(sqrt(1-param[2]*param[2])*sin(param[6]),q,vect2);
       somme(vect1,vect2,result);
       scalvect(param[1],result,r);

      END;

     {********************** CAS HYPERBOLIQUE ********************}

      If param[2]>1 then
      BEGIN

      {Calcul de la vitesse absolue v }

       scalvect(-sinh(param[6]),p,vect1);
       scalvect(sqrt(param[2]*param[2]-1)*cosh(param[6]),q,vect2);
       somme(vect1,vect2,result);
       rayon:=param[1]*(param[2]*cosh(param[6])-1);
       scalvect(sqrt(mu*param[1])/rayon,result,v);

     {Calcul du rayon vecteur r }

       scalvect((param[2]-cosh(param[6])),p,vect1);
       scalvect(sqrt(param[2]*param[2]-1)*sinh(param[6]),q,vect2);
       somme(vect1,vect2,result);
       scalvect(param[1],result,r);
       
      END;

   END;

END.

















