                 { UNIT  UNIT  UNIT  UNIT  UNIT  UNIT }
                 
unit halley;

{------------------------------------------------------------------------------------------------------}
{ Cette unit donne les phmrides de la comte de Halley, pour son passage en 1985-1986
	      datir est la date classique
		   EXEMPLE datir='14031986' pour le 14/03/1986
	      heure est donne comme suit
                   EXEMPLE heure='140256'  pour 14 h 2 mn 56 s
	      mus constante de gravitation solaire
	      imprim =1 si on dsire une sortie des rsultats, comme un but en soi
	      imprim=0 si on ne souhaite pas d'impression des rsultats, notamment dans les calculs
	      r est un vecteur :le rayon vecteur par ses composantes en km
	      v est le vecteur vitesse avec ses composantes en km/s
              NB : Les composantes sont hliocentriques
	      param est un tableau de 7 rels reprsentant les paramtres orbitaux de la plante
		param[1]:demi- grand axe en km
		param[2]:excentricit
		param[3]:inclinaison (ATTENTION: en degrs pour les sorties imprimes mais en radian pour les passages de variables
		param[4]argument nodal du prige (IDEM )
		param[4]:longitude vernale de la ligne des noeuds (IDEM)
		param[6]:anomalie excentrique de la position (IDEM)
		param[7]:date julienne de passage prochain au prige  	       }
{------------------------------------------------------------------------------------------------------}


INTERFACE

uses wincrt,constype,jourjuli,paramrv,fonscal,fonvect;

procedure ephemhalley(datir,heure:string;mus:real;imprim:integer;
		   var param:tabparam;var r,v:vecteur);

IMPLEMENTATION


procedure ephemhalley;

var  i:integer;
     dt,x,mj,sj,jj2000,jjancien,l,lambda:real;
     p,q,w:vecteur;

BEGIN

      param[1] := 2683.881e6;
      param[2] := 0.9672750;
      param[3] := 2.83160839;
      param[4] := 1.95209003;
      param[5] := 1.01479394;
      param[7] := 2446470.95862;

     datejuli(datir,heure,mj,sj,jj2000,jjancien);

    {calcul de l'anomalie excentrique fi en radian, valeur comprise
    entre 0 et 2*pi }
    dt := (jjancien - param[7]);
    if ( dt < 0) then dt := - dt;
    x  := dt * (1/(param[1]*sqrt(param[1]/mus)))*86400;

    {rsolution de l'quation transcendante donnant fi}

    for i:= 1 to 500 do
       begin
         param[6] := x + param[2]*sin(param[6]);
       end;

    dt := (jjancien - param[7]);
    if ( dt < 0) then param[6] :=2*pi - param[6];

    {Calcul grace a la procedure posvitperifocal de la position r,
         de la vitesse v, et des vecteurs p,q,w du repere perifocal.}

           posvitperifocal(mus,param,p,q,w,r,v);

          {Calcul de la longitude heliocentrique de HALLEY}

          l:=arctan(r[2]/r[1]);
	  if (((r[1]<0) and (r[2]>0)) or ((r[1]<0) and (r[2]<0)))
                    then l:=l+pi
		    else
                         if ((r[2]<0) and (r[1]>0))
                            then l:=2*pi+l;

          lambda:= arctan(r[3]/sqrt((r[1]*r[1]+r[2]*r[2])));

{Impression des rsultats sur demande}

   if (imprim=1) then

	    Begin

	      writeln('*******  Caractristiques de la comte de Halley ********'); writeLn;
	      writeln('    La date est le jour:');
	      writeLn('              julien ancien: ',jjancien);
	      writeLn('              julien J2000 : ',jj2000);
	      writeln;
	      writeln('    Voici dans le repere hliocentrique les composantes de:');
	      writeln('       Rayon vecteur en  millions de km:');
	      writeLn('         r[1]= ',r[1]/1e6:6:3,'    r[2]= ',r[2]/1e6:6:3,'    r[3]= ',r[3]/1e6:6:3);
	      writeln('       Vecteur vitesse:');
	      writeLn('         v[1]= ',v[1]:6:3,'    v[2]= ',v[2]:6:3,'      v[3]= ',v[3]:6:3);
              writeLn;
	      write('*****************************************************');
	      writeln;
	      writeln('    longitude heliocentrique: ',l*180/pi:10:4,' degrs');
	      writeln('    Latitude heliocentrique: ',lambda*180/pi:10:4,' degrs');
	      writeLn;
	      writeLn('*****************************************************');
	      writeLn('La distance au soleil est de :',norm(r)/1e6:6:3,' millions km');
	      writeLn('*****************************************************');
	      writeln('    Temps depuis le passage au prige dt= :',dt:8:3, ' jours');
	      writeln('    Anomalie excentrique de la position fi= :',param[6]*180/pi:6:3,' degrs');
	    end;
end;

end.
