                          { UNIT  UNIT  UNIT  UNIT  UNIT }

unit halleyjj;

{------------------------------------------------------------------------------------------------------}
{ Cette unit done les phmrides de la comte de Halley, pour son passage en 1985-1986
	      dattejj est la date julienne en jours de J2000
	      mus constante de gravitation solaire
	      imprim =1 si on dsire une sortie des rsultats, comme un but en soi
	      imprim=0 si on ne souhaite pas d'impression des rsultats, notamment dans les calculs
	      r est un vecteur :le rayon vecteur par ses composantes en km
              v est le vecteur vitesse avec ses composantes en km/s }
{------------------------------------------------------------------------------------------------------}

INTERFACE

uses wincrt,constype,paramrv,fonscal,fonvect;

procedure ephalleyj(datejj,mus:real;imprim:integer;
                   var r,v:vecteur);

IMPLEMENTATION


procedure ephalleyj;

var  i:integer;
     x,jjancien,l,lambda,dt:real;
     p,q,w:vecteur;
     param:tabparam;
BEGIN

      param[1] := 2683.881e6;
      param[2] := 0.9672750;
      param[3] := 2.83160839;
      param[4] := 1.95209003;
      param[5] := 1.01479394;
      param[7] := 2446470.95862;


     {transformation de la date julienne jj2000 en jjancien}
     jjancien := 2451545.0+datejj;

    {calcul de l'anomalie excentrique fi en radian, valeur comprise
    entre 0 et 2*pi}
    dt := (jjancien - param[7]);
    if ( dt < 0) then dt := - dt;
    x  := dt * (1/(param[1]*sqrt(param[1]/mus))*86400);

    {rsolution de l'quation transcendante donnant fi}

    for i:= 1 to 500 do
       begin
	 param[6] := x + param[2]*sin(param[6]);
       end;

       dt := (jjancien - param[7]);
    if ( dt < 0) then param[6] :=2*pi - param[6];

    {Calcul grace a la procedure posvitperifocal de la position r,
	 de la vitesse v, et des vecteurs p,q,r du repere perifocal.}

	   posvitperifocal(mus,param,p,q,w,r,v);

	  {Calcul de la longitude heliocentrique de HALLEY en rd}

	  l:=arctan(r[2]/r[1]);
	  if (((r[1]<0) and (r[2]>0)) or ((r[1]<0) and (r[2]<0)))
		    then l:=l+pi
		    else
			 if ((r[2]<0) and (r[1]>0))
			    then l:=2*pi+l;
	  {Calcul de la latitude heliocentrique de HALLEY en rd}

	  Lambda:=Arctan(r[3]/sqrt(r[1]*r[1]+r[2]*r[2]));
{Impression des rsultats sur demande}

   if (imprim=1) then

	    Begin

	      writeln('*******  Caractristiques de la comte de Halley ********'); writeLn;
	      writeln('    La date est le jour:');
	      writeLn('              julien ancien: ',jjancien);
	      writeLn('              julien J2000 : ',datejj);
	      writeln;
	      writeln('    Voici dans le repere j2000 les composantes de:');
	      writeln('       Rayon vecteur en  millions de km:');
	      writeLn('         r[1]= ',r[1]/1e6:6:3,'    r[2]= ',r[2]/1e6:6:3,'    r[3]= ',r[3]/1e6:6:3);
	      writeln('       Vecteur vitesse:');
	      writeLn('         v[1]= ',v[1]:6:3,'    v[2]= ',v[2]:6:3,'      v[3]= ',v[3]:6:3);
              writeLn;
	      write('*****************************************************');
	      writeln;
	      writeln('    longitude heliocentrique: ',l*180/pi:10:4,' degrs');
	      writeln('    Latitude heliocentrique: ',lambda*180/pi:10:4,' degrs');
	      writeLn;
	      writeLn('*****************************************************');
	      writeLn('La distance au soleil est de :',norm(r)/1e6:6:3,' millions km');


            end;
end;

end.
