program visistat;

uses fonscal,fonvect,wincrt,constype,paramrv;

var lat_station,long_station,long_abs_station,long_sat,lat_sat,k,az,El, Xstat,Ystat,Zstat:real;
    datetravail,JJdate_obs,mut,t_tp,fi,periode,D,tp,Elevation_mini,fi0,fi1:real;
    ch,reponse_question:char;
    nom_satellite,nom_station:String;
    param:tabparam;
    numero,CAS,i,choix:integer;
    p,q,w,rayon_abs,E,N,Z,V,U,rayon_stat:vecteur;
    Precision_temporelle:real;

Label STATIONdifferente_SATidentique,STATIONdifferente_SATdifferent,STATIONidentique_SATdifferent;


{*********************************}
  function GREENWICH(JJdate_obs:real) : real;
    Var u:real;
  BEGIN
    u := 280.45692 + 360.9856474 * JJdate_obs;  { en degrs }

    {L'angle u est ramene entre 0 et 360 degres.}

    u:= u - int(u/360)*360;

    if (u<0) then u:=u+360;

    {Valeur exploitable en radian de l heure siderale.}

    GREENWICH := u*pi/180;

  END;

 {*********************************}
 PROCEDURE CALCUL_RAYON_VECTEUR_LOCAL(heure : real; Var rayon_abs:vecteur;Var D,El,Az:real);
    Var R_station:vecteur;
        Xstat,Ystat,Zstat,Xsat,Ysat,Zsat,interm,
	cos_lat_station,
	sin_lat_station,
	cos_lon_station,
	sin_lon_station,
	N_U:real;
 BEGIN

  long_abs_station:=long_station + GREENWICH(heure /86400);  { Calcul en radians }

  cos_lat_station := cos(lat_station);
  sin_lat_station := sin(lat_station);
  cos_lon_station := cos(long_abs_station);
  sin_lon_station := sin(long_abs_station);

  {Vecteur Znith local}

  Z[1]:= cos_lat_station*cos_lon_station;
  Z[2]:= cos_lat_station*sin_lon_station;
  Z[3]:= sin_lat_station;

  {Coordonnes station en repre absolu}

  Xstat:=6378*Z[1];
  Ystat:=6378*Z[2];
  Zstat:=6378*Z[3];

  {Coordonnes satellite en repre absolu}

  Xsat:= rayon_abs[1];
  Ysat:= rayon_abs[2];
  Zsat:= rayon_abs[3];

  {Distance Station-Satellite}

  D:=Sqrt((Xsat-Xstat)*(Xsat-Xstat)+(Ysat-Ystat)*(Ysat-Ystat)+(Zsat-Zstat)*(Zsat-Zstat));

  {Vecteur unitaire station-Satellite}

  U[1]:= (Xsat-Xstat)/D;
  U[2]:= (Ysat-Ystat)/D;
  U[3]:= (Zsat-Zstat)/D;

  scalvect(D,U,R_station);

 {CALCUL AZIMUT ET ELEVATION}

{Vecteur Nord gographique local}

 N[1]:=  -sin(lat_station)*cos(long_abs_station);
 N[2]:=  -sin(lat_station)*sin(long_abs_station);
 N[3]:=   cos(lat_station);


{Vecteur Est local ---> E}

prodvect(N,Z,E);

{Elvation}

interm:= prodscal(U,Z);

If interm>1 then
 begin
   interm := 0;
   El:=pi/2;
   writeln('     Azimut indfini, satellite  la verticale de la station');
 end
else if interm < -1 then
 begin
   interm := 0;
   El:= -pi/2;
  end
else if(interm >=0) then
  begin
   interm := sqrt(1-interm*interm);
   El := Arccos(interm);
   end
else
  begin
   interm := sqrt(1-interm*interm);
   El := -Arccos(interm);
  end;

{Calcul de l'azimut gographique}

If (interm<>0) then
  begin
    N_U := prodscal(N,U);
    Az:=Arccos(N_U/interm);
    if (prodscal(E,U)<=0) then Az:=2*pi-Az;
  end
else { pas de calcul de Az };

END;

{*********************************}
   PROCEDURE CALCUL_RAYON_VECTEUR_ABSOLU(param:tabparam;fi:real;VAR rayon_abs:vecteur);

    Var  ray:vecteur;
    k:integer;


   BEGIN

    param[6]:=fi;
    posvitperifocal(mut,param,p,q,w,ray,v);

   for k:=1 to 3  do
     begin
 	if abs(ray[k])<1e-6 then ray[k]:=0;
     end;

     rayon_abs:=ray;

   END;
{*********************************}

PROCEDURE SAISIE_STATION_SATELLITE;

Var reponse:char;

Label RETOUR;

BEGIN
writeln;writeln;
writeln('    CE PROGRAMME DONNE LA VISIBILITE D''UN SATELLITE A PARTIR D''UNE STATION');
writeln('                   Guiziou Robert dcembre 2005');
writeln;
writeln('                       **************');
writeln;

RETOUR:

writeln('             SAISIE DES COORDONNEES STATION ET DU SATELLITE');
writeln;
write('     NOM DE LA STATION :?');readln(nom_station);writeln;
write('     NOM DU SATELLITE :?');readln(nom_satellite);writeln;
write('     Donnez la latitude en degrs de la station ? :');
readln(lat_station); writeln;

write('     Donnez la longitude Greenwich en degrs station (>0 vers l''Est) ? :');
readln(long_station);writeln;
write('     Angle minimum (en degrs) de visibilit satellite sur l''horizon ? :');
readln(Elevation_mini);writeln;

write('     Quelle prcision temporelle voulez-vous ( de 2 s  10 s )? Prcision = ');
readln(Precision_temporelle);writeln;

{ Angles en radians }

k:=pi/180;
lat_station:=k*lat_station;
long_station:=k*long_station;

write('     ESTIMEZ-VOUS VOS DONNEES CORECTES ?( o/n )');readln(reponse);writeln;
If Not((reponse='o') or  (reponse='O')) then  goto RETOUR

END;

{*********************************}

PROCEDURE SAISIE_PARAMETRES_ORBITAUX;

Var reponse:char;

Label RETOUR;

BEGIN

RETOUR:
 writeLn;
 writeln('             SAISIE DES CARACTERISTIQUES SATELLITE');
 writeln;
 writeln('   Donnez les parametres orbitaux, attention aux unites');
 writeln;
 write('   Demi grand-axe en KM >>>>>   a= ');Readln(param[1]);
 writeln;
 write('   Excentricite e = ');Readln(param[2]);
 writeln;
 write('   Inclinaison orbitale en degres i = ');Readln(param[3]);
 param[3]:=param[3]*pi/180;
 writeln;
 write('   Argument nodal du perihelie en degres w = ');Readln(param[4]);
 param[4]:=param[4]*pi/180;
 writeln;
 write('   Longitude vernale des noeuds en degres W = ');Readln(param[5]);
 param[5]:=param[5]*pi/180;
 writeln;
 param[6]:=0;
 writeln;
 write('   Date julienne fractionnaire d''un passage au prige tp= ');Readln(tp);
 writeln;
 {writeln('   Numro d''orbite aprs le passage au prige');
 write('   Ce numro vaut N=0 juste aprs passage au prige, numero= ');Readln(numero);}
 writeln;

 write('     ESTIMEZ-VOUS VOS DONNEES CORECTES ?( o/n )');readln(reponse);writeln;
 If Not((reponse='o') or  (reponse='O')) then  goto RETOUR


END;


{*********************************}

 PROCEDURE CHOIX_CAS_DE_CALCUL;

 Var reponse:char;

 label DEBUT;

 BEGIN

 repeat

 writeLn;
 writeln('             CHOIX DU CAS DE CALCUL');
 writeln;

 writeln;
 WriteLn('     TROIS CAS DE CALCUL POSSIBLES :');

 WriteLn('       1 - Le satellite est-il visible  une date julienne donne ? ');
 WriteLn('              Calcul des coordonnes locales  une date donne ');
 WriteLn('              C''est  dire Distance Elvation Azimut ');
 WriteLn;
 WriteLn('       2 - Calcul des coordonnes locales  une date donne ');
 WriteLn('              C''est  dire Distance Elvation Azimut ');
 WriteLn('              mme si le satellite n''est pas visible ');
 WriteLn;
 WriteLn('       3 - Pour un jour Julien J entier donn( Compt  12 h)');
 WriteLn('              Fourniture des plages de visibilit efficaces entre ');
 WriteLn('              0 heure et 24 heures en temps UT du jour calendaire ');

 WriteLn;WriteLn;

DEBUT:

Write('     CHOIX DU CAS  1 ou 2 ou 3, votre choix cas = '); ReadLn(CAS);   WriteLn;

case CAS of
1,2:begin
    	Writeln('     NB : Si votre date est calendaire, allez d''abord excuter DATEJULI.EXE ');WriteLn;
    	Write('     Donnez la date julienne de l''observation date_observation = '); ReadLn(JJdate_obs);WriteLn;
    end;
3:  begin
      Writeln('     NB : Si votre jour est calendaire, pour obtenir un entier il faut excuter  ');
      Writeln('     DATEJULI.EXE pour la date calendaire et choisir imprativement 12 h ');WriteLn;

      repeat
        write('     Donnez le JOUR JULIEN ENTIER ? Jour Julien =');
	readln(datetravail);
	WriteLn;
        If Frac(datetravail) <> 0 then WriteLn( '      Donnez un nombre entier SVP',Frac(datetravail) );
      until (Frac(datetravail) = 0);
    end;
else
    begin
      WriteLn('    Erreur de choix du cas');WriteLn;
      GoTo DEBUT;
    end;
end;

write('     ESTIMEZ-VOUS VOS DONNEES CORRECTES ?( o/n )');readln(reponse);writeln;

until (reponse='o') or  (reponse='O');

  END;

  {*********************************}


PROCEDURE Calcul_fi0;

Var k:integer;
    t_tp0,t_tp1:real;


 { Cas de calcul des crneaux de visibilit sur une journe de J  12 h  J+1 12 h }

BEGIN

 periode:= 2*pi*sqrt(param[1]/mut)*param[1];

 { Calcul de l'anomalie excentrique fi0 entre 0 et 2*pi}
 { correspondant  lma position Jour choisi  12 h }

 t_tp0:=(datetravail-tp)*86400;  { en jours juliens puis secondes}

 { Calcul itratif de fi0 }

 fi0:=0;

 t_tp0:=frac(t_tp0/periode)*periode;

 for k:=1 to 20 do
  begin
    fi0:=t_tp0*2*pi/periode+param[2]*sin(fi0);
  end;

   { Anomalie excentrique fermeture fi1}

  t_tp1:=(datetravail+1-tp)*86400;  { en jours juliens puis secondes}

 { Calcul itratif de fi1 }

 fi1:=0;

 t_tp1:=frac(t_tp1/periode)*periode;

 for k:=1 to 20 do
  begin
    fi1:=t_tp1*2*pi/periode+param[2]*sin(fi1);
  end;


END;

 {*********************************}

 PROCEDURE CAS_1_ou_CAS_2;

Var k:integer;

 { Cas de calcul d'une visibilit  une date prcise }

BEGIN

 periode:= 2*pi*sqrt(param[1]/mut)*param[1];

 { Anomalie excentrique fi entre 0 et 2*pi}

 t_tp:=(JJdate_obs-tp)*86400;  { en jours juliens puis secondes}

 fi:=0;

 t_tp:=frac(t_tp/periode);

 t_tp:=periode*t_tp;

 for k:=1 to 2 do
  begin
    fi:=t_tp*2*pi/periode+param[2]*sin(fi);
  end;


END;

 {*********************************}
 PROCEDURE PASSAGE_VERTICALE_STATION;


   Var Norm_VitHor,CAz,NormVitrHor:real;
       Result,VitHor,Vet,VitrHor,VitRel:vecteur;



  BEGIN

    {Construction de E=result? INTRINSEQUE }

     prodvect(N,Z,result);

    { Oppos vitesse entranement /IJK en km/s}

    Scalvect(-2*pi/86164*(Norm(rayon_abs))*cos(lat_station),result,Vet);

    Somme(Vet,V,VitRel);

    { vitesse relative /ENZ en km/s}

    VitrHor[1]:=Prodscal(VitRel,result);
    VitrHor[2]:=Prodscal(VitRel,N);
    VitrHor[3]:=0;

    CAz:=VitrHor[2]/Norm(VitrHor);
    If (Caz-1)>0 then Caz:=1;
    If (Caz+1)<0 then Caz:=-1;
    Az:=Arccos(CAz);

    If VitrHor[1]<0 Then Az:=-Az;
   END;

{********************************}
  Procedure AFFICHE_RESULTATS_3;
begin
{RESULTATS}
Clrscr;
writeln;
WriteLn('    NB :si le tableau reste vide le satellite n''est pas visible ce jour l');
writeln;
writeln('               *********************************************');
writeln('               *                  RESULTATS                * ');
writeln('               *********************************************');
writeln;
write('      VISIBILITE DU SATELLITE ',NOM_SATELLITE,'  DEPUIS LA STATION ',NOM_STATION);
writeln;
writeln('    La visibilit est effective pour une lvation >',elevation_mini*180/pi:2:0,' degrs');
WriteLn('    Station de latitude : ',lat_station*180/pi:5:2,' degrs',' , de longitude : ',long_station*180/pi:5:2,' degrs');
writeln;
WriteLn('      Prcision de l''entre ou sortie de visibilit : ',precision_temporelle:2:0, ' secondes');
writeln;
End;
{********************************}

Procedure AFFICHE_RESULTATS_1_2;
begin
{RESULTATS}
Clrscr; writeln;
writeln;
writeln('               *********************************************');
writeln('               *                  RESULTATS                * ');
writeln('               *********************************************');
writeln; writeln;
write('     VISIBILITE DU SATELLITE ',NOM_SATELLITE,'  DEPUIS LA STATION ',NOM_STATION);
writeln;
writeln('    La visibilit est calcule pour une lvation de : ',elevation_mini*180/pi:2:0,' degrs');
WriteLn('    Station de latitude : ',lat_station*180/pi:5:2,' degrs','  de longitude : ',long_station*180/pi:5:2,' degrs');
writeln;

if El>=Elevation_mini then
BEGIN
   write('     DISTANCE STATION-SATELLITE =',D:6:0,' Km'); writeln;
   writeln;
   if abs(abs(El)-pi/2)<1e-4 then
     begin
     writeln('     LE SATELLITE EST VISIBLE A LA VERTICALE DE LA STATION');
     writeLn;
     writeln('     L''azimut n''est pas dfini, car le satellite est au zenith de la station');
     PASSAGE_VERTICALE_STATION;
     writeln;
     writeln('     L''azimut prvisible aprs survol station vaut: ',Az*180/pi:6:2,' degrs');
     writeln;

     end;

   if (abs(El)<=pi/2-1e-4) then
     begin
      writeln('     LE SATELLITE EST VISIBLE AU DESSUS DE ', elevation_mini*180/pi:5:2,' degrs');
      writeln;
      writeln('     AZIMUT GEOGRAPHIQUE =',Az*180/pi:6:2,' Degrs');
      writeln;
      write('     ELEVATION SUR L''HORIZON =',El*180/pi :6:2,' Degrs');writeln;
      writeln;
   end;
END
else
BEGIN

   writeln('     LE SATELLITE N''EST PAS VISIBLE AU DESSUS DE ', elevation_mini*180/pi:5:2,' degrs');

   IF CAS=2 Then
   BEGIN

     writeln('        CEPENDANT ON FOURNIT SES COORDONNEES LOCALES');writeLn;
     write('     DISTANCE STATION-SATELLITE =',D:6:0,' Km'); writeln;
     writeln;
     if abs(El)=pi/2 then
       begin
        writeln('     Azimut indfini, satellite au nadir de la station');
        writeln('     Cependant l''azimut futur ou prcdent tait : ');
        writeln;
     end;

     if abs(El)<pi/2 then
       begin
        write('     AZIMUT GEOGRAPHIQUE =',Az*180/pi:6:2,' Degrs'); writeln;
        writeln;
        write('     ELEVATION SOUS L''HORIZON =',El*180/pi :6:2,' Degrs');writeln;
        writeln;
     end;
   END;
END;
END;

 {*********************************}

 PROCEDURE stocker( heure : real; visibilite : boolean);

 VAR nombre_heure,nombre_minute,nombre_seconde:real;
     Heure_TU,excentricite,date_vraie:real;
     ouvert_precedent:boolean;
 begin
     excentricite:=param[2];

     Heure_TU:=12*3600+ Heure-periode * ( fi0 - excentricite * sin(fi0)) / (2*pi); { en secondes}
     nombre_heure:=Int(Heure_TU/3600);
     nombre_minute:=Int((Heure_TU-nombre_heure*3600)/60);
     nombre_seconde:=Int(heure_TU-3600*nombre_heure-60*nombre_minute);
     date_vraie:=datetravail;
     If nombre_heure>=24 then
          Begin
             date_vraie:=datetravail+1;
             nombre_heure:=nombre_heure-24;
          End;

     If (Visibilite) then
       Begin
	  WriteLn('   JOUR JULIEN ',date_vraie:7:0,'   ---   ','DEBUT VISIBILITE A : ',nombre_heure:2:0,' h '
	 ,nombre_minute:2:0,' mn ',nombre_seconde:2:0,' s ');
         ouvert_precedent:=TRUE;
       End;

       If ouvert_precedent and Not(Visibilite) then
       Begin
         WriteLn('   JOUR JULIEN ',date_vraie:7:0,'   ---   ','FIN VISIBILITE A   : ',nombre_heure:2:0,' h '
	 ,nombre_minute:2:0,' mn ',nombre_seconde:2:0,' s ');
         WriteLn;
         ouvert_precedent:=False;
       end;

 end;

 {*********************************}

 PROCEDURE CALCUL_CRENEAUX(fi0:Real);

   const UN_JOUR : real = 86400.0;

   Var excentricite,
       heure_courante,
       heure_initiale,
       Azimut_satellite,
       Elevation_satellite,
       fi,
       deltafi:real;
       visibilite_satellite,
       visibilite_satellite_instant_precedent : boolean;

   BEGIN
     excentricite := param[2];
     visibilite_satellite_instant_precedent := false; { en fait inconnu }
     Deltafi := pi * precision_temporelle / Periode;
     fi := fi0;
     heure_initiale := periode * ( fi0 - excentricite * sin(fi0)) / (2*pi);

     repeat
       heure_courante := periode * ( fi - excentricite * sin(fi)) / (2*pi);

       CALCUL_RAYON_VECTEUR_ABSOLU(param, fi, rayon_abs);
       CALCUL_RAYON_VECTEUR_LOCAL( heure_courante, rayon_abs, D, Elevation_satellite, Azimut_satellite);

       visibilite_satellite := (Elevation_satellite >= Elevation_mini);

       if (visibilite_satellite) then
          Begin
           if not visibilite_satellite_instant_precedent then
              begin
	          { transition non visible vers visible }
                  stocker( heure_courante, true);
                  visibilite_satellite_instant_precedent := true;
	      end;
          End
       else if visibilite_satellite_instant_precedent then
           begin
	          { le satellite devient non visible }
                  stocker( heure_courante, false);
                  visibilite_satellite_instant_precedent := false;
	    end;

       fi := fi + deltafi;
     until heure_courante > heure_initiale + UN_JOUR;


   END;

{ ********************************* PROGRAMME PRINCIPAL *************************************}

BEGIN
mut:=39.860064e4;

{*** Retour pour station et satellites diffrents}

STATIONdifferente_SATdifferent:

SAISIE_STATION_SATELLITE; 
write('         APPUYER SUR UNE TOUCHE POUR CONTINUER LES SAISIES');ch:=readkey;

{*** Retour pour station identique et changement de satellite}

STATIONidentique_SATdifferent:

SAISIE_PARAMETRES_ORBITAUX;

write('         APPUYER SUR UNE TOUCHE POUR CONTINUER LES SAISIES');ch:=readkey;

{*** Retour pour station diffrente et le mme satellite}
STATIONdifferente_SATidentique:

if choix=1 then

 BEGIN
  SAISIE_STATION_SATELLITE;
  write('         APPUYER SUR UNE TOUCHE POUR CONTINUER LES SAISIES');ch:=readkey;
 END;



{   ----------------------- Partie programme commune -----------------------------------}

{ Angle minimum de visibilit au dessus de l'horizon EN RADIANS}
Elevation_mini:=Elevation_mini*pi/180;
CHOIX_CAS_DE_CALCUL;
case cas of
1, 2: begin
	CAS_1_ou_CAS_2;
	CALCUL_RAYON_VECTEUR_ABSOLU(param,fi,rayon_abs);
	CALCUL_RAYON_VECTEUR_LOCAL(JJDate_Obs * 86400, rayon_abs,D,El,Az);
        AFFICHE_RESULTATS_1_2;
      end;
3:    begin
        AFFICHE_RESULTATS_3;
	Calcul_fi0;
        CALCUL_CRENEAUX(fi0);
      end;
end;


WriteLn;WriteLn;
writeln('               *********************************************');
write('                 VOULEZ-VOUS TRAITER UN AUTRE CAS ?  (o/n) ');ReadLn(reponse_question);
writeln;

If (reponse_question='o') or  (reponse_question='O') then

 BEGIN
  writeLn('       AUTRE STATION mais MME SATELLITE ---> TAPER 1');
  writeLn('       AUTRE SATELLITE mais MME STATION --->  TAPER 2');
  writeLn('       AUTRE STATION ET AUTRE SATELLITE TAPER 3');
  writeLn;
  write('    Donnez votre choix 1 2 ou 3 ---> Choix = ? ');ReadLn(choix);writeln;

  If choix=1 then GOTO STATIONdifferente_SATidentique;
  If choix=2 then GOTO STATIONidentique_SATdifferent;
  If choix=3 then GOTO STATIONdifferente_SATdifferent;

  END;

write('    APPUYER SUR UNE TOUCHE POUR QUITTER DEFINITIVEMENT LE PROGRAMME');
ch:=readkey;
donewincrt;


END.

*************************************************************************************************
Donnes pour vrifier CAS 1 ou le CAS 2:
***************************************
**Orbite GTO, prige  200, station sous le prige  t=0
  param[1]:=24371;param[2]:=0.730089;param[3]:=45*pi/180;param[4]:=270*pi/180; param[5]:=280.46*pi/180;
  param[6]:=0;JJdate_obs:=0.017677083   ;tp:=0;lat_station:=-45*pi/180;long_station:=-90*pi/180;

  Cas 1 : Bon au prige avec survol au znith
  Cas 1 : Bon aprs survol au znith, l'azimut est correct
  Cas 2 : Bon pour l'affichage des 2 rsultats

  param[1]:=42164;param[2]:=0;param[3]:=2*pi/180;param[4]:=0*pi/180; param[5]:= 280.46*pi/180;
  param[6]:=0;tp:=0;lat_station:=0*pi/180;long_station:= 0*pi/180; JJdate_obs:=0;

  Cas 2 : OK, le satellite est toujours  la verticale de la station
          Inclinaison 2 qui ne change pas beaucoup la visibilit

  param[1]:=42164;param[2]:=0;param[3]:=2*pi/180;param[4]:=0*pi/180; param[5]:= 280.46*pi/180;
  param[6]:=0;tp:=0;lat_station:=0*pi/180;long_station:= 0*pi/180; JJdate_obs:=0

  CAS 2 :  Trfle vrifi  OK

  param[1]:=42164;param[2]:=0;param[3]:=2*pi/180;param[4]:=0*pi/180; param[5]:= 280.46*pi/180;
  param[6]:=0;tp:=0;lat_station:=0*pi/180;long_station:= 0*pi/180; JJdate_obs:=0

  CAS 2 : Gosynchrone trs excentrique OK , on note que excentricit > 0.6 --> perte satellite
          momentane

  param[1]:=42164;param[2]:=0.73;param[3]:=2*pi/180;param[4]:=0*pi/180; param[5]:= 280.46*pi/180;
  param[6]:=0;tp:=0;lat_station:=0*pi/180;long_station:= 0*pi/180; JJdate_obs:=0

Donnes pour vrifier Cas 3
***************************
      Quasi gostationnaire, inclinaison 2, station sous le croisement des folioles du trfle.

  param[1]:=42164;param[2]:=0;param[3]:=2*pi/180;param[4]:=0*pi/180; param[5]:= 280.46*pi/180;
  param[6]:=0;tp:=0;lat_station:=0*pi/180;long_station:= 0*pi/180; JJdate_obs:=0;

  OK :Visibilit 24 h

   CAS 3 : Gosynchrone trs excentrique OK , on note que excentricit > 0.6 --> perte satellite
          momentane

  param[1]:=42164;param[2]:=0.73;param[3]:=2*pi/180;param[4]:=0*pi/180; param[5]:= 280.46*pi/180;
  param[6]:=0;tp:=0;lat_station:=0*pi/180;long_station:= 0*pi/180; JJdate_obs:=0


  CAS 3 : Phase circulaire 1/4 OK , on doit observer 4 visibilits identiques
          L'azimut doit rester scotch  90  EXCELLENT

  param[1]:=16732.65;param[2]:=0;param[3]:=0*pi/180;param[4]:=0*pi/180; param[5]:= 280.46*pi/180;
  param[6]:=0;tp:=0;lat_station:=0*pi/180;long_station:= 0*pi/180; JJdate_obs:=0
